<template>
  <div class="user-wrapper">
<!--    <span class="action">-->
<!--      <a-icon type="question-circle-o"></a-icon>-->
<!--    </span>-->
<!--    <header-notice class="action"/>-->
    <a-dropdown :trigger="['click']">
      <span class="action ant-dropdown-link user-dropdown-menu">
        <a-avatar class="avatar" size="small" :src="avatar()"/>
        <span>{{ nickname() }}</span>
      </span>
      <a-menu slot="overlay" class="user-dropdown-menu-wrapper">
        <a-menu-item key="2">
          <a href="javascript:;" @click="showEditPwd">
            <a-icon type="edit"/>
            <span>修改密码</span>
          </a>
        </a-menu-item>
        <a-menu-item key="3">
          <a href="javascript:;" @click="handleLogout">
            <a-icon type="logout"/>
            <span>退出登录</span>
          </a>
        </a-menu-item>
      </a-menu>
    </a-dropdown>
    <edit-pwd ref="editPwd" @relogin="relogin"></edit-pwd>
  </div>
</template>

<script>
  import HeaderNotice from './HeaderNotice'
  import EditPwd from './EditPwd'
  import { mapActions, mapGetters } from 'vuex'

  export default {
    name: "UserMenu",
    components: {
      HeaderNotice,
      EditPwd
    },
    methods: {
      ...mapActions(["Logout"]),
      ...mapGetters(["nickname", "avatar"]),
      handleLogout() {
        const that = this

        this.$confirm({
          title: '提示',
          content: '确定要退出登录吗?',
          onOk() {
            return that.Logout({}).then(() => {
              window.location.reload()
            }).catch(err => {
              that.$message.error({
                title: '错误',
                description: err.message
              })
            })
          },
          onCancel() {
          },
        });
      },
      showEditPwd() {
        this.$refs.editPwd.show();
      },
      relogin() {
        let that = this;
        this.$confirm({
          title: '提示',
          content: '密码已修改，请重新登录！',
          onOk() {
            return that.Logout({}).then(() => {
              window.location.reload()
            }).catch(err => {
              that.$message.error({
                title: '错误',
                description: err.message
              })
            })
          },
          onCancel() {
          },
        });
      }
    }
  }
</script>

<style scoped>

</style>